BEGIN;
-- Drop index bindings from system tables
DELETE FROM pg_amproc WHERE amopclaid = (SELECT oid FROM pg_opclass WHERE opcname = 'gist_geometry_ops');
DELETE FROM pg_amop WHERE amopclaid = (SELECT oid FROM pg_opclass WHERE opcname = 'gist_geometry_ops');
DELETE FROM pg_opclass WHERE opcname = 'gist_geometry_ops';
-- Drop all aggregates.
DROP AGGREGATE extent ( geometry );
DROP AGGREGATE memcollect ( geometry );
DROP AGGREGATE collect ( geometry );
DROP AGGREGATE MemGeomUnion ( geometry );
DROP AGGREGATE GeomUnion ( geometry );
-- Drop all operators.
DROP OPERATOR <<  (geometry,geometry);
DROP OPERATOR &<  (geometry,geometry);
DROP OPERATOR &&  (geometry,geometry);
DROP OPERATOR &>  (geometry,geometry);
DROP OPERATOR >>  (geometry,geometry);
DROP OPERATOR ~=  (geometry,geometry);
DROP OPERATOR @  (geometry,geometry);
DROP OPERATOR ~  (geometry,geometry);
DROP OPERATOR <  (geometry,geometry);
DROP OPERATOR <=  (geometry,geometry);
DROP OPERATOR =  (geometry,geometry);
DROP OPERATOR >=  (geometry,geometry);
DROP OPERATOR >  (geometry,geometry);
-- Drop all casts.
DROP CAST ( chip AS geometry );
DROP CAST ( geometry AS box3d );
DROP CAST ( geometry AS box );
DROP CAST ( box3d AS geometry );
DROP CAST ( text AS geometry);
DROP CAST ( wkb AS bytea );
DROP CAST ( box3d AS box );
DROP CAST ( geometry AS text );
-- Drop all functions.
DROP FUNCTION histogram2d_in (cstring);
DROP FUNCTION histogram2d_out (histogram2d);
DROP FUNCTION box3d_in (cstring);
DROP FUNCTION box3d_out (box3d);
DROP FUNCTION spheroid_in (cstring);
DROP FUNCTION spheroid_out (spheroid);
DROP FUNCTION wkb_in (cstring);
DROP FUNCTION wkb_out (wkb);
DROP FUNCTION wkb_recv (internal);
DROP FUNCTION chip_in (cstring);
DROP FUNCTION chip_out (chip);
DROP FUNCTION geometry_in (cstring);
DROP FUNCTION geometry_out (geometry);
DROP FUNCTION postgis_gist_sel  (internal, oid, internal, int4);
DROP FUNCTION postgis_version ();
DROP FUNCTION find_srid (varchar,varchar,varchar);
DROP FUNCTION get_proj4_from_srid (integer);
DROP FUNCTION fix_geometry_columns ();
DROP FUNCTION find_extent (text,text);
DROP FUNCTION transform_geometry (geometry,text,text,int);
DROP FUNCTION transform (geometry,integer);
DROP FUNCTION srid (chip);
DROP FUNCTION height (chip);
DROP FUNCTION factor (chip);
DROP FUNCTION width (chip);
DROP FUNCTION datatype (chip);
DROP FUNCTION compression (chip);
DROP FUNCTION setSRID (chip,int4);
DROP FUNCTION setfactor (chip,float4);
DROP FUNCTION geometry (CHIP);
DROP FUNCTION box3d (geometry);
DROP FUNCTION box (geometry);
DROP FUNCTION geometry (box3d);
DROP FUNCTION geometry (text);
DROP FUNCTION expand (box3d,float8);
DROP FUNCTION asbinary (geometry);
DROP FUNCTION asbinary (geometry,TEXT);
DROP FUNCTION bytea (wkb);
DROP FUNCTION geometry (wkb);
DROP FUNCTION GeomFromWKB (wkb);
DROP FUNCTION GeomFromWKB (wkb,int);
DROP FUNCTION PointFromWKB (wkb,int);
DROP FUNCTION PointFromWKB (wkb);
DROP FUNCTION LineFromWKB (wkb,int);
DROP FUNCTION LineFromWKB (wkb);
DROP FUNCTION LinestringFromWKB (wkb,int);
DROP FUNCTION LinestringFromWKB (wkb);
DROP FUNCTION PolyFromWKB (wkb,int);
DROP FUNCTION PolyFromWKB (wkb);
DROP FUNCTION PolygonFromWKB (wkb,int);
DROP FUNCTION PolygonFromWKB (wkb);
DROP FUNCTION MPointFromWKB (wkb,int);
DROP FUNCTION MPointFromWKB (wkb);
DROP FUNCTION MultiPointFromWKB (wkb,int);
DROP FUNCTION MultiPointFromWKB (wkb);
DROP FUNCTION MultiLineFromWKB (wkb,int);
DROP FUNCTION MultiLineFromWKB (wkb);
DROP FUNCTION MLineFromWKB (wkb,int);
DROP FUNCTION MLineFromWKB (wkb);
DROP FUNCTION MPolyFromWKB (wkb,int);
DROP FUNCTION MPolyFromWKB (wkb);
DROP FUNCTION MultiPolyFromWKB (wkb,int);
DROP FUNCTION MultiPolyFromWKB (wkb);
DROP FUNCTION GeomCollFromWKB (wkb,int);
DROP FUNCTION GeomCollFromWKB (wkb);
DROP FUNCTION npoints (geometry);
DROP FUNCTION nrings (geometry);
DROP FUNCTION mem_size (geometry);
DROP FUNCTION summary (geometry);
DROP FUNCTION translate (geometry,float8,float8,float8);
DROP FUNCTION dimension (geometry);
DROP FUNCTION geometrytype (geometry);
DROP FUNCTION envelope (geometry);
DROP FUNCTION x (geometry);
DROP FUNCTION y (geometry);
DROP FUNCTION z (geometry);
DROP FUNCTION numpoints (geometry);
DROP FUNCTION pointn (geometry,integer);
DROP FUNCTION exteriorring (geometry);
DROP FUNCTION numinteriorrings (geometry);
DROP FUNCTION interiorringn (geometry,integer);
DROP FUNCTION numgeometries (geometry);
DROP FUNCTION geometryn (geometry,integer);
DROP FUNCTION max_distance (geometry,geometry);
DROP FUNCTION optimistic_overlap (geometry,geometry,FLOAT8);
DROP FUNCTION segmentize (geometry,FLOAT8);
DROP FUNCTION distance (geometry,geometry);
DROP FUNCTION astext (geometry);
DROP FUNCTION srid (geometry);
DROP FUNCTION geometryfromtext (geometry,int4);
DROP FUNCTION geometryfromtext (geometry);
DROP FUNCTION geomfromtext (geometry,int4);
DROP FUNCTION geomfromtext (geometry);
DROP FUNCTION polyfromtext (geometry,int4);
DROP FUNCTION polygonfromtext (geometry,int4);
DROP FUNCTION polygonfromtext (geometry);
DROP FUNCTION mpolyfromtext (geometry,int4);
DROP FUNCTION linefromtext (geometry,int4);
DROP FUNCTION mlinefromtext (geometry,int4);
DROP FUNCTION multilinestringfromtext (geometry,int4);
DROP FUNCTION multilinestringfromtext (geometry);
DROP FUNCTION pointfromtext (geometry,int4);
DROP FUNCTION mpointfromtext (geometry,int4);
DROP FUNCTION multipointfromtext (geometry,int4);
DROP FUNCTION multipointfromtext (geometry);
DROP FUNCTION geomcollfromtext (geometry,int4);
DROP FUNCTION setSRID (geometry,int4);
DROP FUNCTION polyfromtext (geometry);
DROP FUNCTION mpolyfromtext (geometry);
DROP FUNCTION multipolygonfromtext (geometry);
DROP FUNCTION multipolygonfromtext (geometry,int);
DROP FUNCTION linefromtext (geometry);
DROP FUNCTION linestringfromtext (geometry);
DROP FUNCTION linestringfromtext (geometry,int);
DROP FUNCTION mlinefromtext (geometry);
DROP FUNCTION pointfromtext (geometry);
DROP FUNCTION mpointfromtext (geometry);
DROP FUNCTION geomcollfromtext (geometry);
DROP FUNCTION isempty (geometry);
DROP FUNCTION issimple (geometry);
DROP FUNCTION equals (geometry,geometry);
DROP FUNCTION length_spheroid (geometry,spheroid);
DROP FUNCTION length3d_spheroid (geometry,spheroid);
DROP FUNCTION distance_spheroid (geometry,geometry,spheroid);
DROP FUNCTION multi (geometry);
DROP FUNCTION length3d (geometry);
DROP FUNCTION length (geometry);
DROP FUNCTION area2d (geometry);
DROP FUNCTION area (geometry);
DROP FUNCTION perimeter3d (geometry);
DROP FUNCTION perimeter (geometry);
DROP FUNCTION point_inside_circle (geometry,float8,float8,float8);
DROP FUNCTION startpoint (geometry);
DROP FUNCTION endpoint (geometry);
DROP FUNCTION isclosed (geometry);
DROP FUNCTION centroid (geometry);
DROP FUNCTION isring (geometry);
DROP FUNCTION pointonsurface (geometry);
DROP FUNCTION xmin (box3d);
DROP FUNCTION ymin (box3d);
DROP FUNCTION zmin (box3d);
DROP FUNCTION xmax (box3d);
DROP FUNCTION ymax (box3d);
DROP FUNCTION zmax (box3d);
DROP FUNCTION box3dtobox (box3d);
DROP FUNCTION geom_accum  (geometry[],geometry);
DROP FUNCTION combine_bbox (box3d,geometry);
DROP FUNCTION collector (geometry,geometry);
DROP FUNCTION collect_garray  (geometry[]);
DROP FUNCTION geometry_overleft (geometry, geometry);
DROP FUNCTION geometry_overright (geometry, geometry);
DROP FUNCTION geometry_left (geometry, geometry);
DROP FUNCTION geometry_right (geometry, geometry);
DROP FUNCTION geometry_contain (geometry, geometry);
DROP FUNCTION geometry_contained (geometry, geometry);
DROP FUNCTION geometry_overlap (geometry, geometry);
DROP FUNCTION geometry_same (geometry, geometry);
DROP FUNCTION geometry_lt (geometry, geometry);
DROP FUNCTION geometry_le (geometry, geometry);
DROP FUNCTION geometry_gt (geometry, geometry);
DROP FUNCTION geometry_ge (geometry, geometry);
DROP FUNCTION geometry_eq (geometry, geometry);
DROP FUNCTION geometry_cmp (geometry, geometry);
DROP FUNCTION force_2d (geometry);
DROP FUNCTION force_3d (geometry);
DROP FUNCTION force_collection (geometry);
DROP FUNCTION intersection (geometry,geometry);
DROP FUNCTION buffer (geometry,float8);
DROP FUNCTION symmetricdifference (geometry,geometry);
DROP FUNCTION GeomUnion (geometry,geometry);
DROP FUNCTION unite_garray  (geometry[]);
DROP FUNCTION relate (geometry,geometry);
DROP FUNCTION relate (geometry,geometry,text);
DROP FUNCTION disjoint (geometry,geometry);
DROP FUNCTION touches (geometry,geometry);
DROP FUNCTION intersects (geometry,geometry);
DROP FUNCTION crosses (geometry,geometry);
DROP FUNCTION within (geometry,geometry);
DROP FUNCTION contains (geometry,geometry);
DROP FUNCTION overlaps (geometry,geometry);
DROP FUNCTION isvalid (geometry);
DROP FUNCTION geosnoop (geometry);
DROP FUNCTION simplify (geometry, float8);
DROP FUNCTION line_interpolate_point (geometry, float8);
DROP FUNCTION update_geometry_stats ();
DROP FUNCTION update_geometry_stats (varchar,varchar);
DROP FUNCTION create_histogram2d (box3d,int);
DROP FUNCTION build_histogram2d  (histogram2d, text, text);
DROP FUNCTION explode_histogram2d  (histogram2d, text);
DROP FUNCTION estimate_histogram2d (histogram2d,box);
DROP FUNCTION postgisgistcostestimate (internal,internal,internal,internal,internal,internal,internal,internal);
DROP FUNCTION ggeometry_consistent (internal,geometry,int4);
DROP FUNCTION ggeometry_compress (internal);
DROP FUNCTION gbox_penalty (internal,internal,internal);
DROP FUNCTION gbox_picksplit (internal, internal);
DROP FUNCTION gbox_union (bytea, internal);
DROP FUNCTION gbox_same (box, box, internal);
DROP FUNCTION rtree_decompress (internal);
DROP FUNCTION geometry_union (geometry,geometry);
DROP FUNCTION geometry_inter (geometry,geometry);
DROP FUNCTION geometry_size (geometry,internal);
DROP FUNCTION AddGeometryColumn (varchar,varchar,varchar,varchar,integer,varchar,integer);
DROP FUNCTION AddGeometryColumn (varchar,varchar,varchar,integer,varchar,integer);
DROP FUNCTION AddGeometryColumn (varchar,varchar,integer,varchar,integer);
DROP FUNCTION DropGeometryColumn (varchar, varchar,varchar,varchar);
DROP FUNCTION DropGeometryColumn (varchar,varchar,varchar);
DROP FUNCTION DropGeometryColumn (varchar,varchar);
-- Drop all types.
DROP TYPE histogram2d ;
DROP TYPE box3d ;
DROP TYPE spheroid ;
DROP TYPE chip ;
DROP TYPE geometry ;
DROP TYPE wkb ;
-- Drop all tables.
DROP TABLE spatial_ref_sys;
DROP TABLE geometry_columns;

COMMIT;
